<?php

use App\Enums\DepositStatusEnum;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('deposits', function (Blueprint $table) {
            $table->id();
            $table->foreignIdFor(\App\Models\User::class)->constrained()->cascadeOnDelete();
            $table->foreignIdFor(\App\Models\Payment::class)->nullable()->constrained()->cascadeOnDelete();
            $table->string('track')->nullable()->unique();
            $table->float('amount');
            $table->unsignedBigInteger(column: 'coins')->default(0);
            $table->string('currency', 10)->default('USD');
            $table->float('charge')->default(0);
            $table->enum('status', DepositStatusEnum::values())->default(DepositStatusEnum::PENDING);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('deposits');
    }
};
